-----------------------------------------------------------------------------
--
-- THIS FILE IS GENERATED AUTOMATICALLY BY TASTE - DON'T MODIFY IT!!!
--
-----------------------------------------------------------------------------
-- LEON3 Demonstration design test bench configuration
-- Copyright (C) 2009 Aeroflex Gaisler
------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Files       : architecture_config.vhd          
-- Version     : 0.1                        
-- Date        : 11/06/2010                 
-- Mofified by : Yann LECLERC - M3Systems   
------------------------------------------------------------------------------

library techmap;
use techmap.gencomp.all;

library ieee;
use ieee.std_logic_1164.all;

package config is
-- Technology and synthesis options
  constant CFG_FABTECH : integer := virtex4;
  constant CFG_MEMTECH : integer := virtex4;
  constant CFG_PADTECH : integer := virtex4;
-- Clock generator
  constant CFG_CLKTECH : integer := virtex4;

-- TASTE specific:
-- If your Synthesis reports that you have to lessen the clock,
-- (i.e. less than 100MHz) , you have to modify these two:
-- (default value: 2x50/1 = 100MHz
  constant CFG_CLKMUL : integer := (2);
  constant CFG_CLKDIV : integer := (1);


  constant CFG_PCIDLL : integer := 0;
  constant CFG_PCISYSCLK: integer := 0;
-- AMBA settings
  constant CFG_DEFMST : integer := (0);
  constant CFG_RROBIN : integer := 1;
  constant CFG_SPLIT : integer := 0;
  constant CFG_AHBIO : integer := 16#FFF#;
  constant CFG_APBADDR : integer := 16#800#;
-- PCI interface
  constant CFG_PCI : integer := 1;
  constant CFG_PCIVID : integer := 16#1AC8#;
  constant CFG_PCIDID : integer := 16#0054#;

-- TASTE specific:
-- types for byte arrays
  type octStr_16 is array (0 to 15) of std_logic_vector(7 downto 0);
  type octStr_24 is array (0 to 23) of std_logic_vector(7 downto 0);


end;
